diff a/src/hotspot/share/oops/instanceMirrorKlass.hpp b/src/hotspot/share/oops/instanceMirrorKlass.hpp
--- a/src/hotspot/share/oops/instanceMirrorKlass.hpp
+++ b/src/hotspot/share/oops/instanceMirrorKlass.hpp
@@ -63,11 +63,12 @@
     assert(k->is_mirror_instance_klass(), "cast to InstanceMirrorKlass");
     return static_cast<const InstanceMirrorKlass*>(k);
   }
 
   // Returns the size of the instance including the extra static fields.
-  virtual size_t oop_size(oop obj) const;
+  size_t oop_size(oop obj, markWord mark) const;
+  int hash_offset_in_bytes(oop obj) const;
 
   // Static field offset is an offset into the Heap, should be converted by
   // based on UseCompressedOop for traversal
   static HeapWord* start_of_static_fields(oop obj) {
     return (HeapWord*)(cast_from_oop<intptr_t>(obj) + offset_of_static_fields());
@@ -87,11 +88,11 @@
 
   // Given a Klass return the size of the instance
   size_t instance_size(Klass* k);
 
   // allocation
-  instanceOop allocate_instance(Klass* k, TRAPS);
+  instanceOop allocate_instance(Klass* k, bool extend, TRAPS);
 
   static void serialize_offsets(class SerializeClosure* f) NOT_CDS_RETURN;
 
   // Oop fields (and metadata) iterators
   //
